Bug 1135122 - httpd.service unit file weirdness
httpd.service unit file weirdness
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: httpd (Show other bugs)
20
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Jan Kaluža
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2014-08-28 16:53 EDT by Lennart Poettering
Modified: 2015-06-29 21:29 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-06-29 21:29:52 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Lennart Poettering 2014-08-28 16:53:50 EDT
I have been looking into the httpd.service unit file, and found this:

 ExecStop=/bin/kill -WINCH ${MAINPID}
 # We want systemd to give httpd some time to finish gracefully, but still want
 # it to kill httpd after TimeoutStopSec if something went wrong during the
 # graceful stop. Normally, Systemd sends SIGTERM signal right after the 
 # ExecStop, which would kill httpd. We are sending useless SIGCONT here to give
 # httpd time to finish.
 KillSignal=SIGCONT

I am pretty sure that (at least in more recent systemd versions) you want to use:

   KillSignal=SIGWINCH
   KillMode=mixed

This will send SIGWINCH to the main pid when the unit is supposed to go down, and then after a timeout send SIGKILL to everything that is remaining in the entire cgroup.

(Note that KillMode=mixed is the key here, since it does the first kill only on the main process, and the second kill on the entire cgroup. It is a relatively new addition though, so please be careful before backporting such a unit file change too eagerly...)
Comment 1 Jan Kaluža 2014-08-29 01:50:26 EDT
Thanks for the info, we have used this originally because the KillMode=mixes has not been implemented yet. I will update httpd.service.
Comment 2 Jan Kaluža 2014-09-01 04:04:45 EDT
I've fixed it in rawhide, Systemd in F20 does not include KillMode=mixed yet. I will backport to F21 soon.
Comment 3 Fedora End Of Life 2015-05-29 08:45:21 EDT
This message is a reminder that Fedora 20 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 20. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '20'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 20 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 4 Fedora End Of Life 2015-06-29 21:29:52 EDT
Fedora 20 changed to end-of-life (EOL) status on 2015-06-23. Fedora 20 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.